class Laserpoint { //basic point of light
  float x,y,z,r,g,b,intens; //the 4/6 basic properties of a point
  Laserpoint (float new_x, float new_y, float new_z) {
    x = new_x;
    y = new_y;
    z = new_z;
    r = 1.0;
    g = 1.0;
    b = 1.0;
  }
    Laserpoint (float new_x, float new_y, float new_z, float new_intens) {
    x = new_x;
    y = new_y;
    z = new_z;
    r = new_intens;
    g = new_intens;
    b = new_intens;
  }
    Laserpoint (float new_x, float new_y, float new_z, float new_r, float new_g, float new_b) {
    x = new_x;
    y = new_y;
    z = new_z;
    r = new_r;
    g = new_g;
    b = new_b;
  }
}

class Lasersegment { //two or more connected points with no break in between
  Laserpoint[] lpoint; //a segment is an array of points
  PVector anchor;
    int pointcount; //number of points in a segment, a softcount for reference
    float pitch,roll,yaw;
    Lasersegment () {
      lpoint = new Laserpoint[0];
      pointcount=0;
      anchor = new PVector(0,0,0);
    }
    Lasersegment (Laserpoint new_lpoint) { //a single dot is represented by two identical points in a segment
      lpoint = new Laserpoint[2];
      lpoint[0] = new_lpoint;
      lpoint[1] = new_lpoint;
      anchor = new PVector(0,0,0);
      pointcount=1;
    }
    Lasersegment (Laserpoint[] new_lpoint) { //take multiple points in a segment
     lpoint = new Laserpoint[new_lpoint.length];
     arraycopy(new_lpoint,lpoint);
     pointcount=new_lpoint.length;
     anchor = new PVector(0,0,0);
    }

    Laserpoint getPoint (int pointnumber) {
      return new Laserpoint(lpoint[pointnumber].x,lpoint[pointnumber].y,lpoint[pointnumber].z);
    }
    
    void updateLpoint (int pointnumber, Laserpoint new_lpoint) {
      lpoint[pointnumber] = new_lpoint;
      if (pointcount==1) { 
        lpoint[0] = new_lpoint;
        lpoint[1] = new_lpoint;
      }
    }
    
    void addLpoint (Laserpoint new_lpoint) {
      switch (pointcount) {
        case 0:
          lpoint = (Laserpoint[]) append(lpoint, new_lpoint);
          lpoint = (Laserpoint[]) append(lpoint, new_lpoint);
          pointcount=1;
          break;
      
        case 1:
          lpoint[1] = new_lpoint;
          pointcount++;
          break;
     
        default:
          lpoint = (Laserpoint[]) append(lpoint, new_lpoint);
          pointcount++;
        
      }      
   }
   
   void addLpoint (Laserpoint[] new_lpoint) { //take multiple points in a segment
     if (pointcount == 1) lpoint = (Laserpoint[]) shorten(lpoint);
     lpoint = (Laserpoint[]) concat(lpoint, new_lpoint);
     pointcount+=new_lpoint.length;
  }
   
   void setAnchor(float new_x, float new_y, float new_z) {
     anchor.x = new_x;
     anchor.y = new_y;
     anchor.z = new_z;
   }
   void transLseg(float new_x, float new_y, float new_z) {
     double[] transforms = {new_x, new_y, new_z};
     double[] pointvals = new double[3];
     Matrix trans = new Matrix(transforms,3);
     Matrix pointmat;
     for (int i = 0; i < lpoint.length; i++) {
       pointvals[0] = (double) lpoint[i].x;
       pointvals[1] = (double) lpoint[i].y;
       pointvals[2] = (double) lpoint[i].z;
       pointmat = new Matrix(pointvals,3);
       pointmat.plusEquals(trans);
       lpoint[i] = new Laserpoint((float) pointmat.get(0,0),(float)pointmat.get(1,0),(float)pointmat.get(2,0));
     }
       anchor.x+=new_x;
       anchor.y+=new_y;
       anchor.z+=new_z;
   }
   
   void rotZ(float theta) {
     double[][] transforms = {
      {cos(theta), sin(theta),0}
      ,{-sin(theta), cos (theta), 0}
      ,{0,0,1}
     };
     double[] anchvals = {(double) anchor.x,(double) anchor.y, (double) anchor.z};
     double[] pointvals = new double[3];
     Matrix rot = new Matrix(transforms,3,3);
     Matrix anch = new Matrix(anchvals,3);
     //Matrix results;
     Matrix pointmat;
     for (int i = 0; i < lpoint.length; i++) {
       pointvals[0] = (double) lpoint[i].x;
       pointvals[1] = (double) lpoint[i].y;
       pointvals[2] = (double) lpoint[i].z;
       pointmat = new Matrix(pointvals,3);
       pointmat.minusEquals(anch);
       pointmat = rot.times(pointmat);
       pointmat.plusEquals(anch);
       lpoint[i] = new Laserpoint((float) pointmat.get(0,0),(float)pointmat.get(1,0),(float)pointmat.get(2,0));
     }
   } 
}

class Laserframe { //two or more segments
  Lasersegment[] lsegment;
  int pointcount,segmentcount; //total points in a frame, 
  //updated from segment point count each time seg is added
  //and totals segments in frame
  Laserframe () {
    lsegment = new Lasersegment[0];
    pointcount = 0;
  }
  
  Laserframe (Lasersegment new_seg[]) {
    int seglen = new_seg.length;
    int new_seg_index = 0;
    lsegment = new Lasersegment[seglen];
    for (int i = 0; i < seglen; i++) {
      lsegment[i] = new_seg[i];
      segmentcount++;
      pointcount+=new_seg[i].pointcount;
    }
  }

  Laserframe (Lasersegment new_seg) {
    lsegment = new Lasersegment[1];
    lsegment[0] = new_seg;
    segmentcount++;
    pointcount+=new_seg.pointcount;
  }
  
  void addLsegment (Lasersegment new_seg) {
     lsegment = (Lasersegment[]) append(lsegment, new_seg);
     pointcount+=new_seg.pointcount;
     segmentcount++;
  }
  
  void updateLsegment(int segnumber, Lasersegment new_seg) {
    pointcount= pointcount - lsegment[segnumber].pointcount + new_seg.pointcount;
    lsegment[segnumber] = new_seg;
    //println(pointcount);
  }
  
  /*void compLFrame(Laserframe newframe) {
  }*/
  
  void display() {
    boolean frame_end=false;  
    for (int i=0; i < lsegment.length; i++) {
      beginShape(POLYGON);
      for (int j = 0; j < lsegment[i].lpoint.length; j++) {
        stroke(lsegment[i].lpoint[j].r,lsegment[i].lpoint[j].g,lsegment[i].lpoint[j].b,0.5);
        //fill(lsegment[i].lpoint[j].r,lsegment[i].lpoint[j].g,lsegment[i].lpoint[j].b,0.3);
       // fill(lsegment[i].lpoint[j].r,lsegment[i].lpoint[j].g,lsegment[i].lpoint[j].b);
        vertex(lsegment[i].lpoint[j].x,lsegment[i].lpoint[j].y,lsegment[i].lpoint[j].z);
        //vertex(0,0,0);
      }
      endShape();
      noFill();
    }
 /*   pushMatrix();
    translate(-250,-250);*/
  /*  beginShape(LINES);
    for (int buffindex = 0, i = 0; frame_end != true && buffindex < 19000; buffindex++) {
      if (feedBuf.get(buffindex) == 1799) continue;
      if (feedBuf.get(buffindex) == 1792) continue;
      if (feedBuf.get(buffindex) == 9999) {
        frame_end = true;
        continue;
      }
      fill(feedBuf.get(buffindex+3),feedBuf.get(buffindex+4),feedBuf.get(buffindex+5));
      stroke(feedBuf.get(buffindex+3),feedBuf.get(buffindex+4),feedBuf.get(buffindex+5));
      vertex(feedBuf.get(buffindex),feedBuf.get(buffindex+1));
      ellipse(feedBuf.get(buffindex),feedBuf.get(buffindex+1),2,2);
      buffindex+=6;
    }
    endShape();
    noFill();*/
  }
  void glLaserRender() {
    int current_point =0;
    Lasersegment prevseg=lsegment[0];
    gl = pgl.beginGL();
    gl.glShadeModel(GL.GL_FLAT);
    gl.glFeedbackBuffer(20000, GL.GL_3D_COLOR, feedBuf);
    gl.glRenderMode(GL.GL_FEEDBACK);
    for (int i=0; i < lsegment.length; i++) {
      int seglen = lsegment[i].lpoint.length;
      gl.glBegin(GL.GL_LINES);
      gl.glColor3f(0,0,0);
      gl.glVertex3f(prevseg.lpoint[prevseg.pointcount-1].x,prevseg.lpoint[prevseg.pointcount-1].y,prevseg.lpoint[prevseg.pointcount-1].z);
      gl.glVertex3f(lsegment[i].lpoint[0].x,lsegment[i].lpoint[0].y,lsegment[i].lpoint[0].z);
      gl.glEnd();
      gl.glBegin(GL.GL_LINES);
      for (int j = 0; j < seglen; j++) {
        gl.glColor3f(lsegment[i].lpoint[j].r,lsegment[i].lpoint[j].g,lsegment[i].lpoint[j].b);
        gl.glVertex3f(lsegment[i].lpoint[j].x,lsegment[i].lpoint[j].y,lsegment[i].lpoint[j].z);
        //s.text("Current Point: "+current_point,10,50);
        current_point++;
      }
      gl.glEnd();
/*      gl.glBegin(GL.GL_LINES);
      gl.glColor3f(0,0,0);
      gl.glVertex3f(lsegment[i].lpoint[seglen-1].x,lsegment[i].lpoint[seglen-1].y,lsegment[i].lpoint[seglen-1].z+0.001);
      gl.glVertex3f(lsegment[i].lpoint[seglen-1].x,lsegment[i].lpoint[seglen-1].y,lsegment[i].lpoint[seglen-1].z+0.001);
      gl.glEnd();*/
      prevseg=lsegment[i];
    }
 /*   gl.glBegin(GL.GL_LINES);
    gl.glColor3f(0,0,0);
    gl.glVertex3f(lsegment[i].lpoint[seglen-1].x,lsegment[i].lpoint[seglen-1].y,lsegment[i].lpoint[seglen-1].z+0.001);
    gl.glVertex3f(lsegment[i].lpoint[seglen-1].x,lsegment[i].lpoint[seglen-1].y,lsegment[i].lpoint[seglen-1].z+0.001);
    gl.glEnd();    */
    gl.glPassThrough(9999);
    gl.glRenderMode(GL.GL_RENDER);
    pgl.endGL();
  }
}

interface Lasershape{ //an organized calculated set of points that can be animated
  int frames = 0;
  int framepointer = 0;
  //void create();
  Laserframe animate();
}

class Lasercolor { //class to hold 3 floats from 0 to 1 for laser color
  float r,g,b;
  
  Lasercolor(float _r, float _g, float _b) {
  r = _r;
  g = _g;
  b = _b;
  }
}
