import Jama.util.*;
import Jama.*;
import promidi.*;
import com.softsynth.jsyn.*;
import com.softsynth.jsyn.util.*;
import processing.opengl.*;
import javax.media.opengl.*;
import java.awt.event.*;
import javax.swing.*;
import processing.dxf.*;
import java.nio.*;
import javax.media.opengl.glu.*;
import com.sun.opengl.util.*; 
import com.sun.opengl.util.FPSAnimator; 
import java.io.RandomAccessFile;
import java.io.IOException;


float feedBuffer[] = new float[20000];
FloatBuffer feedBuf = BufferUtil.newFloatBuffer(20000);
PGraphicsOpenGL pgl;
GL gl;

float x_rotval = 0;
float y_rotval = 0;
float z_rotval = 0;
PMatrix3D initial_pos;

boolean latch = false;
boolean reset = true;
boolean input_block = false;
boolean AUTO_OPTIMIZE= false;

int blueoff = 6;

Lasershape[] showshapes = new Lasershape[25];
//Laserpoint p1,p2;
Lasersegment line1,line2;
Laserframe frame1;
Laserframe current;
Lasershape currentshape;
laSquare mysquare;
laIlda smiley;
laIlda testpattern;
laWiggles wiggles;
laPearls mypearls;
laLatSphere mylat;
laRipple myripple;

MidiIO midiIO;

int nowplaying = 0;

//File myfile; 
RandomAccessFile raf; 
WAVFileWriter wfw; 

void setup() {
  size(500,500,OPENGL);
  frameRate(30);
  //smooth();
  colorMode(RGB,1.0);
  background(0);
  strokeWeight(1);
  noFill();
  translate(250,250);
  sphereDetail(3);
  pushMatrix();
  initial_pos = new PMatrix3D();
  getMatrix(initial_pos);
  /*try {
    raf = new RandomAccessFile("h:/wavout.wav", "rw");
  }
  catch (FileNotFoundException fnfe) {
    println("File not found: " + fnfe);
    return;
  }
  
  try {
    wfw = new WAVFileWriter(raf);
  }
  catch (IOException fnfe) {
    println("File not found: " + fnfe);
    return;
  }
  try {
    wfw.writeHeader(0);
    wfw.writeFormatChunk( 16,6,30000);
    wfw.writeDataChunkHeader(0);
  }
  catch (IOException fnfe) {
    println("File not found: " + fnfe);
    return;
  }*/
  current = new Laserframe();

  init6chan(30000.0f,0,5); //start up sound system freq, indev, outdev

  showshapes[0] = new vanBlinds();
  showshapes[1] = new laHexes();
  showshapes[2] = new laBoids();
  showshapes[3] = new laSquareTun(4);
  showshapes[4] = new laStarfield();
  showshapes[5] = new laText("Hi!");
  showshapes[6] = new laDigitalClock();
  showshapes[7] = new laLatSphere(12);
  showshapes[8] = new laRipple();
  showshapes[9] = new laBeam(100,100,0,1,1,1);
  showshapes[10] = new laBeam(-100,-100,0,1,1,1);
  showshapes[11] = new laBeam(0,0,0,1,1,1);
  showshapes[12] = new laBeam(0,-100,0,1,1,1);
  showshapes[13] = new laSquare();
  current = showshapes[0].animate();
  
  //AUTO_OPTIMIZE = true;
  lwave = new LaserWave6();
  lwave.start();

  pgl= (PGraphicsOpenGL) g;
  
  /*Frame f = new Frame("Status");
  GLCanvas canvas = new GLCanvas();
  canvas.addGLEventListener(new GLRenderer());
  f.add(canvas);
  f.setSize(500, 500);
  f.setLocation(0,0);
  //f.setUndecorated(true);
  f.show();
  FPSAnimator animator = new FPSAnimator(canvas, 10);
  animator.start(); */
  
  midiIO = MidiIO.getInstance(this);
  //println("printPorts of midiIO");
  //midiIO.printDevices();
  //midiIO.openInput(0,0);

}

void draw() {
  background(0);
  popMatrix();
  if (reset == true) { 
    reset = false;
    setMatrix(initial_pos);
  }
  rotateY(y_rotval);
  rotateX(x_rotval);
  rotateZ(z_rotval);

  current = showshapes[nowplaying].animate();
  current.display();
  pushMatrix();
  current.glLaserRender();

if(keyPressed) {
    if(key == ' ' && input_block == false) {
     
      latch = false;
  //    current_shape++;
  //    if (current_shape > total_pats) current_shape = 20;
      z_rotval = 0;
      x_rotval = 0;
      y_rotval = 0;
      reset = true;
     input_block = true;
//      initGenerative(current_shape);
   }
    if(key == 'b') {
      blueoff++;
      println(blueoff);
      reset = false;
    }
    if(key == 'B') {
      blueoff--;
      println(blueoff);
      reset = false;
    }
    if(key == 'z') {
      z_rotval+=0.01;
      reset = false;
    }
    if(key == 'a') {
      z_rotval-=0.01;
      reset = false;
    }
    if(key == 'x') {
      x_rotval+=0.01;
      reset = false;
    }
    if(key == 's') {
      x_rotval-=0.01;
      reset = false;
    }
    if(key == 'c') {
      y_rotval+=0.01;
      reset = false;
    }
    if(key == 'd') {
      y_rotval-=0.01;
      reset = false;
    }
    if(key == ',' && input_block == false) {
      if (nowplaying >= 9) nowplaying =0;
      else nowplaying++;
      reset = false;
      input_block = true;
    }      
  }
}

void keyReleased() {
  input_block = false;
}

void stop() {
  //synthContext.stop();
  //synthContext.stopEngine();
 // Synth.stopEngine();
/*  try {
    wfw.fixSizes();
    raf.close();
  }
  catch (IOException fnfe) {
    println("File not found: " + fnfe);
    return;
  }*/
}

void mousePressed() {
 /*   try {
    wfw.fixSizes();
    raf.close();
  }
  catch (IOException fnfe) {
    println("File not found: " + fnfe);
    return;
  }*/
  exit(); 
}
