SynthContext    synthContext;
SampleReader_16F1 ch0Sampler;
SampleReader_16F1 ch1Sampler;
SampleReader_16F1 ch2Sampler;
SampleReader_16F1 ch3Sampler;
SampleReader_16F1 ch4Sampler;
SampleReader_16F1 ch5Sampler;

ChannelOut cout0;
ChannelOut cout1;
ChannelOut cout2;
ChannelOut cout3;
ChannelOut cout4;
ChannelOut cout5;

SampleQueueOutputStream ch0Queue;
SampleQueueOutputStream ch1Queue;
SampleQueueOutputStream ch2Queue;
SampleQueueOutputStream ch3Queue;
SampleQueueOutputStream ch4Queue;
SampleQueueOutputStream ch5Queue;

LaserWave6 lwave;
Thread signalThread; 

int BUFF_SIZE = 4096;

class LaserWave6 extends Thread {
    
  public short[] left = new short[BUFF_SIZE];
  public short[] right = new short[BUFF_SIZE];
  public short[] redmod = new short[BUFF_SIZE];
  public short[] greenmod = new short[BUFF_SIZE];
  public short[] bluemod = new short[BUFF_SIZE];
  
  public float now_reading = 0;
  public int write_frames = 0;
  public void run() {
    int frames;
    float new_x,new_y;
    float old_x=250;
    float old_y=250;
    float pointdist;
    float threshold=4.0;
    while(1 != 0) {
      frames = 0;
        boolean frame_end = false;
        for (int buffindex = 0, i = 0; frame_end != true && buffindex < 19000; buffindex++) {
          if (feedBuf.get(buffindex) == 1799) continue;
          if (feedBuf.get(buffindex) == 1792) continue;
          if (feedBuf.get(buffindex) == 9999) {
            frame_end = true;
            continue;
          }
          new_x = feedBuf.get(buffindex);
          new_y = feedBuf.get(buffindex+1);
          pointdist=dist(new_x,new_y,old_x,old_y);
          //if ((abs(new_x-old_x) > 3 || abs(new_y-old_y) > 3) && AUTO_OPTIMIZE == true) {
          if (pointdist > threshold && AUTO_OPTIMIZE == true) {
            float fillpoints = dist(new_x,new_y,old_x,old_y)/threshold;
            for (int opti = 0; opti <= fillpoints; opti++) {
              float x = lerp(old_x,new_x,(float) opti/fillpoints);
              float y = lerp(old_y,new_y,(float) opti/fillpoints);
              left[i] = (short) int(map (x,0,500,-32000,32000));
              right[i] = (short) int(map (y,0,500,32000,-32000));
              redmod[i] = (short) int(map (feedBuf.get(buffindex+3),0,1,0,-32000));
              greenmod[i] = (short) int(map (feedBuf.get(buffindex+4),0,1,0,-32000));
              bluemod[i] = (short) int(map (feedBuf.get(buffindex+5),0,1,0,-32000));
              if (frames > now_reading) now_reading = frames;
              short[] samples = {left[i],right[i],redmod[i],greenmod[i],bluemod[i],0};
              i++;
              frames++;
           /*   try {
              for (int k=0; k < samples.length; k++) {
                //println();
                wfw.writeShortLittle(samples[k]);
              }
            }
            catch (IOException fnfe) {
              println("File not found: " + fnfe);
              return;
            }*/    
            }
          }
          else {
            left[i] = (short) int(map (new_x,0,500,-32000,32000));
            right[i] = (short) int(map (new_y,0,500,32000,-32000));
            redmod[i] = (short) int(map (feedBuf.get(buffindex+3),0,1,0,-32000));
            greenmod[i] = (short) int(map (feedBuf.get(buffindex+4),0,1,0,-32000));
            bluemod[i] = (short) int(map (feedBuf.get(buffindex+5),0,1,0,-32000));
            if (frames > now_reading) now_reading = frames;
            short[] samples = {left[i],right[i],redmod[i],greenmod[i],bluemod[i],0};
            i++;
            frames++;
     /*       try {
              for (int k=0; k < samples.length; k++) {
                //println();
                wfw.writeShortLittle(samples[k]);
              }
            }
            catch (IOException fnfe) {
              println("File not found: " + fnfe);
              return;
            }*/            
          }
          buffindex+=6;
          old_x=new_x;
          old_y=new_y;
        }
      
      //write_frames = buffindex;
  System.arraycopy(bluemod, 0, bluemod, blueoff, bluemod.length-blueoff);
    // if (ch0Queue.available() > frames) {
       ch0Queue.write(right, 0, frames);
       ch1Queue.write(left, 0, frames);
       ch2Queue.write(redmod,0,frames);
       ch3Queue.write(greenmod, 0, frames);
       ch4Queue.write(bluemod, 0, frames);

       //ch5Queue.write(redmod,0,frames);
      // }     
    }
  }
}

void init6chan(float freq, int indev, int outdev) {
  synthContext = new SynthContext();
  synthContext.initialize();     
  int outDeviceID = outdev;     // usb sound
  int inDeviceID = indev;    // usb sound
  int outMax = AudioDevice.getMaxOutputChannels(outDeviceID);
  int inMax = AudioDevice.getMaxInputChannels(inDeviceID);
  int numDevices = AudioDevice.getNumDevices();
  //println(outDeviceID+":"+outMax+"--"+inDeviceID+":"+inMax+"--"+numDevices);
  synthContext.start(0, freq, inDeviceID,inMax, outDeviceID, outMax );
  int time = synthContext.getTickCount() + 500;

  ch0Sampler = new SampleReader_16F1(synthContext);
  ch1Sampler = new SampleReader_16F1(synthContext);
  ch2Sampler = new SampleReader_16F1(synthContext);
  ch3Sampler = new SampleReader_16F1(synthContext);
  ch4Sampler = new SampleReader_16F1(synthContext);
  ch5Sampler = new SampleReader_16F1(synthContext);  
  
  ch0Queue = new SampleQueueOutputStream (ch0Sampler.samplePort, BUFF_SIZE, 1);
  ch1Queue = new SampleQueueOutputStream (ch1Sampler.samplePort, BUFF_SIZE, 1);
  ch2Queue = new SampleQueueOutputStream (ch2Sampler.samplePort, BUFF_SIZE, 1);
  ch3Queue = new SampleQueueOutputStream (ch3Sampler.samplePort, BUFF_SIZE, 1);
  ch4Queue = new SampleQueueOutputStream (ch4Sampler.samplePort, BUFF_SIZE, 1);
  ch5Queue = new SampleQueueOutputStream (ch5Sampler.samplePort, BUFF_SIZE, 1);
  
  cout0 = new ChannelOut(synthContext,1); //channel 1 for x
  cout1 = new ChannelOut(synthContext,0); //channel 0 for y
  cout2 = new ChannelOut(synthContext,4); // channel 4 for red
  cout3 = new ChannelOut(synthContext,5);
  cout4 = new ChannelOut(synthContext,2);
  cout5 = new ChannelOut(synthContext,3);

  ch0Sampler.output.connect(0,cout0.input,0);
  ch1Sampler.output.connect(0,cout1.input,0);
  ch2Sampler.output.connect(0,cout2.input,0);
  ch3Sampler.output.connect(0,cout3.input,0);
  ch4Sampler.output.connect(0,cout4.input,0);
  ch5Sampler.output.connect(0,cout5.input,0);
  
  cout0.start(time);
  cout1.start(time);
  cout2.start(time);
  cout3.start(time);
  cout4.start(time);
  cout5.start(time);
  
  ch0Sampler.start(time);
  ch1Sampler.start(time);
  ch2Sampler.start(time);
  ch3Sampler.start(time);
  ch4Sampler.start(time);
  ch5Sampler.start(time);
  
  ch0Queue.start(time);
  ch1Queue.start(time);
  ch2Queue.start(time);
  ch3Queue.start(time);
  ch4Queue.start(time);
//  ch5Queue.start(time);
}
  
